"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    'botlist.space': {
        api_docs: 'https://botlistspace.gitbook.io/api/',
        api_post: 'https://api.botlist.space/v1/bots/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: 'shards',
        api_get: 'https://api.botlist.space/v1/bots/:id',
    },
    'botsfordiscord.com': {
        api_docs: 'https://botsfordiscord.gitbook.io/docs/',
        api_post: 'https://botsfordiscord.com/api/bot/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://botsfordiscord.com/api/bot/:id',
    },
    'bots.ondiscord.xyz': {
        api_docs: 'https://bots.ondiscord.xyz/info/api',
        api_post: 'https://bots.ondiscord.xyz/bot-api/bots/:id/guilds',
        api_field: 'guildCount',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: null,
    },
    'discordapps.dev': {
        api_docs: 'https://discordapps.dev/en-GB/posts/docs/api-v2/',
        api_post: 'https://api.discordapps.dev/api/v2/bots/:id',
        api_field: 'bot.count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://api.discordapps.dev/api/v2/bots/:id',
    },
    'discord.boats': {
        api_docs: 'https://discord.boats/api/docs',
        api_post: 'https://discord.boats/api/bot/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://discord.boats/api/bot/:id',
    },
    'discordbots.org': {
        api_docs: 'https://discordbots.org/api/docs',
        api_post: 'https://discordbots.org/api/bots/:id/stats',
        api_field: 'server_count',
        api_shard_id: 'shard_id',
        api_shard_count: 'shard_count',
        api_shards: 'shards',
        api_get: null,
    },
    'discordbotlist.com': {
        api_docs: 'https://discordbotlist.com/api-docs',
        api_post: 'https://discordbotlist.com/api/bots/:id/stats',
        api_field: 'guilds',
        api_shard_id: 'shard_id',
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://discordbotlist.com/api/bots/:id',
    },
    'discordbotreviews.xyz': {
        api_docs: 'https://discordbotreviews.xyz/api/docs',
        api_post: 'https://discordbotreviews.xyz/api/bot/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://discordbotreviews.xyz/api/bot/:id',
    },
    'discordbot.world': {
        api_docs: 'https://discordbot.world/docs',
        api_post: 'https://discordbot.world/api/bot/:id/stats',
        api_field: 'guild_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: 'shards',
        api_get: 'https://discordbot.world/api/bot/:id/stats',
    },
    'discord.bots.gg': {
        api_docs: 'https://discord.bots.gg/docs',
        api_post: 'https://discord.bots.gg/api/v1/bots/:id/stats',
        api_field: 'guildCount',
        api_shard_id: 'shardId',
        api_shard_count: 'shardCount',
        api_shards: null,
        api_get: 'https://discord.bots.gg/api/v1/bots/:id',
    },
    'discordbotslist.us.to': {
        api_docs: null,
        api_post: 'https://discordbotslist.us.to/api/postStats/:id',
        api_field: 'guilds',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: null,
    },
    'discordbots.group': {
        api_docs: 'https://docs.discordbots.group/',
        api_post: 'https://api.discordbots.group/v1/bot/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: 'shards',
        api_get: 'https://api.discordbots.group/v1/bot/:id',
    },
    'discord.services': {
        api_docs: 'https://discord.services/api/',
        api_post: 'https://discord.services/api/bots/:id',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: 'https://discord.services/api/bots/:id',
    },
    'discordsbestbots.xyz': {
        api_docs: 'https://docs.discordsbestbots.xyz/',
        api_post: 'https://discordsbestbots.xyz/api/bots/:id/stats',
        api_field: 'guilds',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://discordsbestbots.xyz/api/bots/:id',
    },
    'discordbots.fun': {
        api_docs: 'https://docs.discordbots.fun/',
        api_post: 'http://discordbots.fun/api/bots/:id',
        api_field: 'serverCount',
        api_shard_id: null,
        api_shard_count: null,
        api_shards: null,
        api_get: null,
    },
    'divinediscordbots.com': {
        api_docs: 'https://divinediscordbots.com/api',
        api_post: 'https://divinediscordbots.com/bot/:id/stats',
        api_field: 'server_count',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://divinediscordbots.com/bot/:id/stats',
    },
    'lbots.org': {
        api_docs: 'https://lbots.org/api/docs',
        api_post: 'https://lbots.org/api/v1/bots/:id/stats',
        api_field: 'guild_count',
        api_shard_id: 'shard_id',
        api_shard_count: 'shard_count',
        api_shards: null,
        api_get: null,
    },
    'wonderbotlist.com': {
        api_docs: 'https://api.wonderbotlist.com/en/',
        api_post: 'https://api.wonderbotlist.com/v1/bot/:id',
        api_field: 'serveurs',
        api_shard_id: null,
        api_shard_count: 'shards',
        api_shards: null,
        api_get: 'https://api.wonderbotlist.com/v1/bot/:id',
    },
};
//# sourceMappingURL=fallbackListData.js.map